jQuery(document).ready(function($)
{
	var sid;
	var pid;
	
	$.each(fwdzoomerPresetsObj, function(i, el){
		$("#fwdzoomer_presets_list").append("<option value='" + el.name + "'>" + el.name + "</option>");
	});

	$("#fwdzoomer_presets_list").change(function(){
		presetId = $("#fwdzoomer_presets_list option:selected").val();
		$("#fwdzoomer_shortcode").val(getShortcode());
	});
	
	$("#fwdzoomer_playlists_list").change(function(){
		pid = $("#fwdzoomer_playlists_list option:selected").val();
		console.log("caca");
		$("#fwdzoomer_shortcode").val(getShortcode());
	});
	
	$("#rl_item_auto_open").change(function(){
		autoopen = $("#fwdrl_presets_list option:selected").val();
		$("#fwdzoomer_shortcode").val(getShortcode());
	});
	
	$("#mgz_item_auto_open").change(function(){
		$("#fwdzoomer_shortcode").val(getShortcode());
	});
	
	
	
	$('.fwdMGZInputFleds').each(function() {
	   var elem = $(this);

	   // Save current value of element
	   elem.data('oldVal', elem.val());

	   // Look for changes in the value
	   elem.bind("propertychange change click keyup input paste", function(event){
		  // If value has changed...
		  if (elem.data('oldVal') != elem.val()) {
		   // Updated stored value
		   elem.data('oldVal', elem.val());
		  
		   $("#fwdzoomer_shortcode").val(getShortcode());
		 }
	   });
	 });
	
	
	function setShortodeIntext(){
		getShortcode();
		if(fwdzoomerPlaylistsObj.length > 0){
			$("#fwdzoomer_shortcode").val('[fwdzoomer preset_name="' + sid + '" image_name="' + pid + '"]');
			$("#fwdzoomer_shortcode").show();
		}else{
			$("#fwdzoomer_shortcode").hide();
		}
	}
	
	$("#fwdzoomer_div").hide();
	
	if (fwdzoomerPlaylistsObj.length > 0){
		
		$.each(fwdzoomerPlaylistsObj, function(i, el){
			$("#fwdzoomer_playlists_list").append("<option value='" + el.name + "'>" + el.name + "</option>");
		});

		$("#fwdzoomer_playlists_list").change(function(){
			playlistId = $("#fwdzoomer_playlists_list option:selected").val();
			$("#fwdzoomer_shortcode").val(getShortcode());
		});
		
	}else{
		var td = $("#fwdzoomer_playlists_list").parent();
		
		$("#fwdzoomer_playlists_list").remove();
		td.append("<em style='margin-left:8px; color:#FF0000;'>No images are available.</em>");
		$("#fwdzoomer_presets_list").prop("disabled", true);
		$("#fwdzoomer_presets_list").css("cursor", "default");
		$("#fwdzoomer_shortcode_btn").prop("disabled", true);
		$("#fwdzoomer_shortcode_btn").css("cursor", "default");
		$("#id_or_class_input").prop("disabled", true);
		$("#id_or_class_input").css("cursor", "default");
	}
	
	$("#fwdzoomer_shortcode_btn").click(function(){	
		addShortcodeFinal();
		return false;
	});
	
	function addShortcodeFinal(){
			var shortcode = getShortcode();
			
			if (typeof tinymce != "undefined"){
			    var editor = tinymce.get("content");
			    
			    if (editor && (editor instanceof tinymce.Editor) && ($("textarea#content:hidden").length != 0)) {
			        editor.selection.setContent(shortcode);
			        editor.save({no_events: true});
			    }else{
					var text = $("textarea#content").val();
					var select_pos1 = $("textarea#content").prop("selectionStart");
					var select_pos2 = $("textarea#content").prop("selectionEnd");
					
					var new_text = text.slice(0, select_pos1) + shortcode + text.slice(select_pos2);
					
					$("textarea#content").val(new_text);
			    } 
			}else{
				var text = $("textarea#content").val();
				var select_pos1 = $("textarea#content").prop("selectionStart");
				var select_pos2 = $("textarea#content").prop("selectionEnd");
				
				var new_text = text.slice(0, select_pos1) + shortcode + text.slice(select_pos2);
				
				$("textarea#content").val(new_text);
			}
			
			$("#fwdzoomer_div").hide();
			$("#fwdzoomer_div").fadeIn(600);
			$("#fwdzoomer_div").html("The shortcode has been added!");
			
			return false;
	}
	
	
	function getShortcode(){
		sid = $("#fwdzoomer_presets_list option:selected").val();
		pid = $("#fwdzoomer_playlists_list option:selected").val();
		var fwdzoomer_shortcode = '[fwdzoomer preset_name="' + sid + '" image_name="' + pid + '"]';
		
		return fwdzoomer_shortcode;
	}
	
	sid = $("#fwdzoomer_presets_list").val();
	pid = $("#fwdzoomer_playlists_list").val();
	setShortodeIntext();
});